/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.9 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 28.03.2014
Author  : F4CG                            
Company : F4CG                            
Comments: 


Chip type           : ATmega16
Program type        : Application
Clock frequency     : 12,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega16


#pragma used+
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb OCDR=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-




// USART Receiver buffer
unsigned char rx_buffer[2];

unsigned char rx_wr_index,rx_rd_index,rx_counter;

// This flag is set on USART Receiver buffer overflow
bit rx_buffer_overflow;
                                       
// USART Receiver interrupt service routine
interrupt [12] void usart_rx_isr(void)
{
unsigned char status,data;
status=UCSRA;
data=UDR;
if ((status & ((1<<4) | (1<<2) | (1<<3)))==0)
   {   
   rx_buffer[rx_wr_index]=data;
   if (++rx_wr_index == 2) rx_wr_index=0;
   if (++rx_counter == 2)
      {
      rx_counter=0;
      rx_buffer_overflow=1;
      };     
   };
}
                    
void putchar1(unsigned char c){
  //while ((UCSRA & DATA_REGISTER_EMPTY)==0);
  while(!(UCSRA & (1<<5)));
  UDR=c;
} 

// Get a character from the USART Receiver buffer
#pragma used+
unsigned char getchar(void)
{
unsigned char data;     
while (rx_counter==0);
data=rx_buffer[rx_rd_index];
if (++rx_rd_index == 2) rx_rd_index=0;
#asm("cli")
--rx_counter;
#asm("sei")
return data;
}
#pragma used-

// Standard Input/Output functions
// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;
typedef char *va_list;
typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib



// Declare your global variables here
                
unsigned char command=0;// 
unsigned char engine=0;//  

unsigned char keys=0;//    
unsigned char keys0=0;//

unsigned char encode=0;// 
unsigned char encode0=0;// 
unsigned char encodeOld=0;//        
unsigned char direction=0;//    

unsigned char mode=0;//0- /   - 1      

//unsigned char command_table[27]={0b00000000,0b0000000l,0b00000010,0b00000100,0b0000010l,0b00000110,0b00001000,0b0000100l,0b00001010,0b00010000,0b0001000l,0b00010010,0b00010100,0b0001010l,0b00010110,0b00011000,0b0001100l,0b00011010,0b00100000,0b0010000l,0b00100010,0b00100100,0b0010010l,0b00100110,0b00101000,0b0010100l,0b00101010};
unsigned char command_table[27]={0x00,0x01,0x02,0x04,0x05,0x06,0x08,0x09,0x0a,0x10,0x11,0x12,0x14,0x15,0x16,0x18,0x19,0x1a,0x20,0x21,0x22,0x24,0x25,0x26,0x28,0x29,0x2a};
unsigned char validCommand(unsigned char c){
        int i;
        for(i=0;i<27;i++){
                if(c==command_table[i]){return command_table[i];}
        }                                            
        return 255;
}
  
void main(void)
{
// Declare your local variables here

// Reset Source checking
if (MCUCSR & 1)
   {
   // Power-on Reset
   MCUCSR&=0xE0;
   // Place your code here

   }
else if (MCUCSR & 2)
   {
   // External Reset
   MCUCSR&=0xE0;
   // Place your code here

   }
else if (MCUCSR & 4)
   {
   // Brown-Out Reset
   MCUCSR&=0xE0;
   // Place your code here

   }
else if (MCUCSR & 8)
   {
   // Watchdog Reset
   MCUCSR&=0xE0;
   // Place your code here

   }
else if (MCUCSR & 0x10)
   {
   // JTAG Reset
   MCUCSR&=0xE0;
   // Place your code here

   };

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0xff;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0xff;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0xff;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 19200
UCSRA=0x00;
UCSRB=0x98;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x31;//0x26;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// Global enable interrupts
#asm("sei")
                 
printf("OK BOUNTY\r\n");

while (1)
      {  
      // Place your code here     
      //        
      //       -
      //      50   ,   

      if(keys0 == ~PINA){keys= ~PINA;}
      keys0= ~PINA;    
        
      if(encode0==PINC){encode=PINC;}
      encode0=PINC;

      //    ,   ,   
      direction=0;                                                 
      if((encode & 0x01) != (encodeOld & 0x01)){
        // 
        direction |= 0x03;
      }  
                                       
      if((encode & 0x02) != (encodeOld & 0x02)){
        // 
        direction |= 0x0c;             
//printf("0x0c\r\n");
      }                                       
      
      if((encode & 0x04) != (encodeOld & 0x04)){
        // 
        direction |= 0x30;
      }                   
      direction &= command;
//printf("E %i old %i D %i\r\n",(encode & 0x02), (encodeOld & 0x02), direction);    
      encodeOld = encode;
  
//printf("B command = %i mode=%i encode=%i\r\n", command,mode,encode);
      
        if(mode==0){
                command=getchar();
                //     
//PORTB = command;                  
                command-=0x31;// ,     0,       31 ("1")
                //  ,   mode=1      
                if(validCommand(command)!=255){
//putsf("valid ");
                        mode=1;
                }               
        }
        
        if(mode==1){    
//putsf("mode=1 ");       
                //    
//printf("C %i ",command);
                command = (keys & command) ^ command;
//printf("K %i C %i\r\n", keys, command);
                // engine   
                engine = (direction & command) ^ command;
//printf("engine = (%i & %i) ^ %i = %i\r\n", direction,command,command, engine);
        
                PORTB=engine;    
                //   , 
                if((engine & 0x3f) == 0){
                        putchar1(command);     
                        mode=0;     
                        encode0=0;
                        encode=0;
                        encodeOld=0;
//printf("command = %i mode=%i\r\n", command,mode);
                }
        } 
        
        delay_ms(50);//   
      };
}
